/// <reference types="knockout" />
import { UiElement, UiElementOptions, IUiElement } from "./uiElement";
export interface ChildrensUiElementOptions<TChild extends IUiElement> extends UiElementOptions {
    children?: Array<TChild> | KnockoutObservableArray<TChild>;
}
export declare abstract class ChildrensUiElement<TChild extends IUiElement> extends UiElement {
    protected constructor(tagName: string, type: string, options?: ChildrensUiElementOptions<TChild>);
    private renderChildren;
    protected build(): void;
    protected options: ChildrensUiElementOptions<TChild>;
    getChildren(): Array<TChild>;
    setChildren(children: Array<TChild>): void;
    addChild(newChild: TChild, referenceChild?: TChild): void;
    removeChild(element: TChild): void;
    clear(): void;
}
